Subject: Re: bug#39799: 28.0.50; Most emoji sequences don’t render correctly

From: Eli Zaretskii <[email-masked]>
Date: Fri, 28 Feb 2020 15:08:59 +0200

> From: Robert Pluim <[email-masked]>
> Cc: Mike FABIAN <[email-masked]>,  [email-masked]
> Date: Fri, 28 Feb 2020 13:21:59 +0100
> 
>     Eli> I'd prefer not to add Python as prerequisite for building Emacs.  We
>     Eli> already use Awk, so using that'd be fine.
> 
> I suck at awk, but my attempt is attached.

Thanks.  I wonder if we could make the output more human-readable...
Glenn, any advice or comments?

> It DTRT for me under Cairo if I change my fontset settings to use
> 'Noto Color Emoji' instead of Symbola for:

Is that a free font (it's from Google, AFAIK, so it might not be)?  If
it is free, we could modify fontset.el to use this font if available.
(Or maybe there are better free Emoji fonts out there?)

>              (#x1F300 . #x1F5FF)	;; Misc Symbols and Pictographs
>              (#x1F900 . #x1F9FF)	;; Supplemental Symbols and Pictographs
> 
> It matches forward off the first char, so the
> composition-function-table entries all have '0' as the number of chars
> to match. Would it be better to match backwards?

I don't think matching backwards is better in general.  Did you have a
reason for thinking it was?

> Weʼd run into the 4-character maximum for that, since some of the
> sequences are 7 or more characters long.

If the sequences are 7 character long, then the forward-matching
pattern will hit the same limitation as well, no?

>     >> > If you mean they are not displayed in correct colors, then Emacs
>     >> > doesn't yet support color emoji, we lack some infrastructure for
>     >> > that.  Again, work in that area is welcome, it should be relatively
>     >> > easy since we now have HarfBuzz support for text shaping.
>     >> 
>     >> Actually the color display works already. I tested with current master
>     >> (build with cairo) and the emoji display just fine in color.
> 
>     Eli> Maybe in a Cairo build.  Or maybe I'm missing something.
> 
> Iʼm not seeing colour emoji in a -Q Cairo build. Which sequence is this
> again?

The ones in http://www.unicode.org/Public/emoji/12.0/emoji-sequences.txt,
and specifically the flag sequences and the skin color sequences.  At
least AFAIU the original report.